--------------------------------------------------------------------------------
-- SubModule IRIGB_serial
-- Created   2/2/2009 2:29:31 PM
--------------------------------------------------------------------------------
library IEEE;
use IEEE.Std_Logic_1164.all;

entity IRIGB_serial is port
   (
     CLK         : in    std_logic;
     IRIGB       : out   std_logic;
     POSMARK     : in    std_logic;
     POSCNT      : in    std_logic_vector (3 downto 0);
     SYMMARK     : in    std_logic;
     SYMCNT      : in    std_logic_vector (3 downto 0);
     POSEND      : in    std_logic;
     ZEROEND     : in    std_logic;
     ONEEND      : in    std_logic;
     BITS        : in    std_logic_vector(88 downto 0)
   );
end IRIGB_serial;
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
architecture Structure of IRIGB_serial is

-- Component Declarations

-- Signal Declarations
   signal shift       : std_logic_vector (88 downto 0);

begin
   irigb_gen: process (CLK) is
   begin
      if rising_edge (CLK) then
         if (POSMARK = '1') or (SYMMARK = '1') then
            IRIGB <= '1';
         elsif (POSEND = '1') then
            IRIGB <= '0';
            if (POSCNT = X"0") and (SYMCNT = X"0") then
               shift <= BITS;
            end if;
         elsif (ZEROEND = '1') then
            if (shift(0) = '0') then
               IRIGB <= '0';
            end if;
         elsif (ONEEND  = '1') then
            if (shift(0) = '1') then
               IRIGB <= '0';
            end if;
            shift <= '0' & shift (88 downto 1);
         end if;
      end if;
   end process irigb_gen;

end Structure;
--------------------------------------------------------------------------------
