--------------------------------------------------------------------------------
-- EEPROM Writer
-- Reads & writes LEAP, TZ, & DST information from & to the EEPROM
--
-- Ilya Belopolski
-- 23 August, 2010
--------------------------------------------------------------------------------

library IEEE;
Use IEEE.Std_Logic_1164.all;
Use IEEE.Numeric_Std.all;

entity LeapTest is port
    (
      CLK          : in std_logic;
--      RST          : in std_logic;
--      PREPPS       : in std_logic;
--      SET_LEAP     : in std_logic;
--      SET_UP       : in std_logic;
--      SET_DOWN     : in std_logic;
--      SET_ADD      : in std_logic;
--      SET_SUB      : in std_logic;
      IS_LEAP      : in std_logic;
      IS_LAST      : in std_logic;
      LEAPPEND     : in std_logic;
      LEAPDEL      : in std_logic;
      LEAP_CHG     : in std_logic;

 --     RSTcounterB       : out std_logic_vector (31 downto 0);
--      PREPPScounterB    : out std_logic_vector (31 downto 0);
--      SET_LEAPcounterB  : out std_logic_vector (31 downto 0);
--      SET_UPcounterB    : out std_logic_vector (31 downto 0);
--      SET_DOWNcounterB  : out std_logic_vector (31 downto 0);
--      SET_ADDcounterB   : out std_logic_vector (31 downto 0);
--      SET_SUBcounterB   : out std_logic_vector (31 downto 0)
      IS_LEAPcounterB   : out std_logic_vector (31 downto 0);
      IS_LASTcounterB   : out std_logic_vector (31 downto 0);
      LEAPPENDcounterB   : out std_logic_vector (31 downto 0);
      LEAPDELcounterB   : out std_logic_vector (31 downto 0);
      LEAP_CHGcounterB  : out std_logic_vector (31 downto 0)

    );
end LeapTest;
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
architecture ark of LeapTest is

--     signal RSTold : std_logic;
--     signal PREPPSold : std_logic;
--     signal SET_LEAPold : std_logic;
--     signal SET_UPold : std_logic;
--     signal SET_DOWNold : std_logic;
--     signal SET_SUBold : std_logic;
--     signal SET_ADDold : std_logic;
     signal IS_LEAPold : std_logic;
     signal IS_LASTold : std_logic;
     signal LEAPPENDold : std_logic;
     signal LEAPDELold : std_logic;
     signal LEAP_CHGold : std_logic;

--     signal RSTrise : std_logic;
--     signal PREPPSrise : std_logic;
--     signal SET_LEAPrise : std_logic;
--     signal SET_UPrise : std_logic;
--     signal SET_DOWNrise : std_logic;
--     signal SET_SUBrise : std_logic;
--     signal SET_ADDrise : std_logic;
     signal IS_LEAPrise : std_logic;
     signal IS_LASTrise : std_logic;
     signal LEAPPENDrise : std_logic;
     signal LEAPDELrise : std_logic;
     signal LEAP_CHGrise : std_logic;

--     signal RSTcounter : integer := 0;
--     signal PREPPScounter : integer := 0;--std_logic_vector (31 downto 0);
--     signal SET_LEAPcounter : integer := 0;--std_logic_vector (31 downto 0);
--     signal SET_UPcounter : integer := 0;--std_logic_vector (31 downto 0);
--     signal SET_DOWNcounter : integer := 0;--std_logic_vector (31 downto 0);
--     signal SET_SUBcounter : integer := 0;--std_logic_vector (31 downto 0);
--     signal SET_ADDcounter : integer := 0;--std_logic_vector (31 downto 0);
     signal IS_LEAPcounter : integer := 0;-- std_logic_vector (31 downto 0);
     signal IS_LASTcounter : integer := 0;-- std_logic_vector (31 downto 0);
     signal LEAPPENDcounter : integer := 0;--std_logic_vector (31 downto 0);
     signal LEAPDELcounter : integer := 0;--std_logic_vector (31 downto 0);
     signal LEAP_CHGcounter : integer := 0;--std_logic_vector (31 downto 0);


begin

--     RSTold <= RST when rising_edge (CLK);
--     PREPPSold <= PREPPS when rising_edge (CLK);
--     SET_LEAPold <= SET_LEAP when rising_edge (CLK);
--     SET_UPold <= SET_UP when rising_edge (CLK);
--     SET_DOWNold <= SET_DOWN when rising_edge (CLK);
--     SET_ADDold <= SET_ADD when rising_edge (CLK);
--     SET_SUBold <= SET_SUB when rising_edge (CLK);
     IS_LEAPold <= IS_LEAP when rising_edge (CLK);
     IS_LASTold <= IS_LAST when rising_edge (CLK);
     LEAPPENDold <= LEAPPEND when rising_edge (CLK);
     LEAPDELold <= LEAPDEL when rising_edge (CLK);
     LEAP_CHGold <= LEAP_CHG when rising_edge (CLK);

--     RSTrise <= '1' when RSTold = '0' and RST = '1' else '0';
--     PREPPSrise <= '1' when PREPPSold = '0' and PREPPS = '1' else '0';
--     SET_LEAPrise <= '1' when SET_LEAPold = '0' and SET_LEAP = '1' else '0';
--     SET_UPrise <= '1' when SET_UPold = '0' and SET_UP = '1' else '0';
--     SET_DOWNrise <= '1' when SET_DOWNold = '0' and SET_DOWN = '1' else '0';
     IS_LEAPrise <= '1' when IS_LEAPold = '0' and IS_LEAP = '1' else '0';
     IS_LASTrise <= '1' when IS_LASTold = '0' and IS_LAST = '1' else '0';
     LEAPPENDrise <= '1' when LEAPPENDold = '0' and LEAPPEND = '1' else '0';
     LEAPDELrise <= '1' when LEAPDELold = '0' and LEAPDEL = '1' else '0';
     LEAP_CHGrise <= '1' when LEAP_CHGold = '0' and LEAP_CHG = '1' else '0';

     track : process (CLK) is
     begin
          if rising_edge (CLK) then

--             if RSTrise = '1' then
--                RSTcounter <= RSTcounter + 1;
--             elsif PREPPSrise = '1' then
--                PREPPScounter <= PREPPScounter + 1;
--             elsif SET_LEAPrise = '1' then
--                SET_LEAPcounter <= SET_LEAPcounter + 1;
--             elsif SET_UPrise = '1' then
--                SET_UPcounter <= SET_UPcounter + 1;
--             elsif SET_DOWNrise = '1' then
--                 SET_DOWNcounter <= SET_DOWNcounter + 1;
--             elsif SET_UPrise = '1' then
--                SET_UPcounter <= SET_UPcounter + 1;
             if IS_LEAPrise = '1' then
                IS_LEAPcounter <= IS_LEAPcounter + 1;
             elsif IS_LASTrise = '1' then
                IS_LASTcounter <= IS_LASTcounter + 1;
             elsif LEAPPENDrise = '1' then
                LEAPPENDcounter <= LEAPPENDcounter + 1;
             elsif LEAPDELrise = '1' then
                LEAPDELcounter <= LEAPDELcounter + 1;
             elsif LEAP_CHGrise = '1' then
                LEAP_CHGcounter <= LEAP_CHGcounter + 1;
             end if;

          end if;
     end process track;

--     RSTcounterB      <= std_logic_vector(To_unsigned(RSTcounter,32));
--     PREPPScounterB   <= std_logic_vector(To_unsigned(PREPPScounter,32));
--     SET_LEAPcounterB <= std_logic_vector(To_unsigned(SET_LEAPcounter,32));
--     SET_UPcounterB   <= std_logic_vector(To_unsigned(SET_UPcounter,32));
--     SET_DOWNcounterB <= std_logic_vector(To_unsigned(SET_DOWNcounter,32));
--     SET_UPcounterB   <= std_logic_vector(To_unsigned(SET_UPcounter,32));
     IS_LEAPcounterB  <= std_logic_vector(To_unsigned(IS_LEAPcounter,32));
     IS_LASTcounterB  <= std_logic_vector(To_unsigned(IS_LASTcounter,32));
     LEAPPENDcounterB  <= std_logic_vector(To_unsigned(LEAPPENDcounter,32));
     LEAPDELcounterB  <= std_logic_vector(To_unsigned(LEAPDELcounter,32));
     LEAP_CHGcounterB <= std_logic_vector(To_unsigned(LEAP_CHGcounter,32));

end architecture ark;
