--------------------------------------------------------------------------------
-- Choose which message to send to the display driver.
-- Ilya Belopolski
-- 15 August, 2010
--------------------------------------------------------------------------------
Library IEEE;
Use IEEE.Std_Logic_1164.all;
use IEEE.Numeric_Std.all;

entity MessageMUX is port
   (
     CLK            : in    std_logic;
     TZ_SWITCH      : in    std_logic;
     LEAP_SWITCH    : in    std_logic;
     GPS_MESS       : in    std_logic_vector(79 downto 0);
     TZ_MESS        : in    std_logic_vector(79 downto 0);
     LEAP_MESS      : in    std_logic_vector(79 downto 0);
     OUT_MESS       : out   std_logic_vector(79 downto 0)
   );
end MessageMUX;
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
architecture ark of MessageMUX is

     signal theMESS       : std_logic_vector(79 downto 0);

begin

     chooseMESS : process (CLK) is
     begin
          if rising_edge (CLK) then
             if (TZ_SWITCH = '1') then
                theMESS <= TZ_MESS;
             elsif (LEAP_SWITCH = '1') then
                theMESS <= LEAP_MESS;
             else
                theMESS <= GPS_MESS;
             end if;
          end if;
     end process chooseMESS;

     OUT_MESS <= theMESS;

end architecture ark;
