--------------------------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.Std_Logic_1164.all;
USE IEEE.Std_Logic_Unsigned.all;
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
ENTITY Configurable_U108 IS
  PORT(
      Q    : OUT std_logic_vector(6 downto 0);
      CLR  : IN  std_logic;
      CEO  : OUT std_logic;
      TC   : OUT std_logic;
      CE   : IN  std_logic;
      C    : IN  std_logic
  );
END Configurable_U108;
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
ARCHITECTURE structure OF Configurable_U108 IS
--------------------------------------------------------------------------------
CONSTANT cMaxValue : std_logic_vector(6 downto 0) := "1111111";
CONSTANT cMinValue : std_logic_vector(6 downto 0) := (OTHERS => '0');
SIGNAL Y : std_logic_vector(6 downto 0) := cMinValue;
SIGNAL TC_int: std_logic;
--------------------------------------------------------------------------------
BEGIN
    PROCESS(C, CLR)
    BEGIN
        IF CLR = '1' THEN
            Y <= cMinValue;
        ELSIF C'Event and C = '1' THEN
            IF (CE = '1') THEN
                IF Y >= cMaxValue THEN
                    Y <= cMinValue;
                ELSE
                    Y <= Y + 1;
                END IF;
            END IF;
        END IF;
    END PROCESS;
    TC_int <= '1' WHEN (Y = cMaxValue) ELSE
              '0';
    Q <= Y;
    TC <= TC_int;
    CEO <= TC_int AND CE;
END structure;
--------------------------------------------------------------------------------
