--------------------------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.Std_Logic_1164.all;
USE IEEE.Std_Logic_arith.all;
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
ENTITY Configurable_U127 IS
  PORT(
      A    : IN std_logic_vector(25 downto 0) :=(OTHERS => 'U');
      B    : IN std_logic_vector(25 downto 0) :=(OTHERS => 'U');
      EQ   : OUT std_logic := '0'
  );
END Configurable_U127;
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
ARCHITECTURE structure OF Configurable_U127 IS
--------------------------------------------------------------------------------
SIGNAL SA : std_logic_vector(25 downto 0);
SIGNAL SB : std_logic_vector(25 downto 0);
--------------------------------------------------------------------------------
BEGIN
    SA <= A;
    SB <= B;
    PROCESS(SA, SB)
    BEGIN
        IF (SA = SB) THEN
            EQ <= '1';
        ELSE
            EQ <= '0';
        END IF;
    END PROCESS;
END structure;
--------------------------------------------------------------------------------
