------------------------------------------------------------
-- VHDL IRIGB
-- 2016 5 5 10 28 11
-- Created By "Altium Designer VHDL Generator"
-- "Copyright (c) 2002-2014 Altium Limited"
-- Product Version: 15.1.15.50867
------------------------------------------------------------

------------------------------------------------------------
-- VHDL IRIGB
------------------------------------------------------------

Library IEEE;
Use     IEEE.std_logic_1164.all;

Entity IRIGB Is
  port
  (
    BITS     : Out   STD_LOGIC_VECTOR(88 DOWNTO 0);          -- ObjectKind=Port|PrimaryId=BITS[88..0]
    CLK      : In    STD_LOGIC;                              -- ObjectKind=Port|PrimaryId=CLK
    DST      : In    STD_LOGIC;                              -- ObjectKind=Port|PrimaryId=DST
    GPS      : In    STD_LOGIC_VECTOR(31 DOWNTO 0);          -- ObjectKind=Port|PrimaryId=GPS[31..0]
    IEEE1344 : In    STD_LOGIC;                              -- ObjectKind=Port|PrimaryId=IEEE1344
    IRIG     : Out   STD_LOGIC;                              -- ObjectKind=Port|PrimaryId=IRIG
    ISLAST   : Out   STD_LOGIC;                              -- ObjectKind=Port|PrimaryId=ISLAST
    ISLEAP   : Out   STD_LOGIC;                              -- ObjectKind=Port|PrimaryId=ISLEAP
    LEAP     : In    STD_LOGIC_VECTOR(7 DOWNTO 0);           -- ObjectKind=Port|PrimaryId=LEAP[7..0]
    LEAPDEL  : In    STD_LOGIC;                              -- ObjectKind=Port|PrimaryId=LEAPDEL
    LEAPPEND : In    STD_LOGIC;                              -- ObjectKind=Port|PrimaryId=LEAPPEND
    ONEPPS   : In    STD_LOGIC;                              -- ObjectKind=Port|PrimaryId=ONEPPS
    TIMEZONE : In    STD_LOGIC_VECTOR(5 DOWNTO 0)            -- ObjectKind=Port|PrimaryId=TIMEZONE[5..0]
  );
  attribute MacroCell : boolean;

End IRIGB;
------------------------------------------------------------

------------------------------------------------------------
Architecture Structure Of IRIGB Is
   Component IRIGB_clock                                     -- ObjectKind=Sheet Symbol|PrimaryId=IRIGBCLK
      port
      (
        CLK     : in  STD_LOGIC;                             -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_clock.vhd-CLK
        ONEEND  : out STD_LOGIC;                             -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_clock.vhd-ONEEND
        ONEPPS  : in  STD_LOGIC;                             -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_clock.vhd-ONEPPS
        POSCNT  : out STD_LOGIC_VECTOR(3 downto 0);          -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_clock.vhd-POSCNT[3..0]
        POSEND  : out STD_LOGIC;                             -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_clock.vhd-POSEND
        POSMARK : out STD_LOGIC;                             -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_clock.vhd-POSMARK
        SYMCNT  : out STD_LOGIC_VECTOR(3 downto 0);          -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_clock.vhd-SYMCNT[3..0]
        SYMMARK : out STD_LOGIC;                             -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_clock.vhd-SYMMARK
        ZEROEND : out STD_LOGIC                              -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_clock.vhd-ZEROEND
      );
   End Component;

   Component IRIGB_encoder                                   -- ObjectKind=Sheet Symbol|PrimaryId=IRIGBENCODE
      port
      (
        BITS     : out STD_LOGIC_VECTOR(88 downto 0);        -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_encoder.vhd-BITS[88..0]
        CLK      : in  STD_LOGIC;                            -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_encoder.vhd-CLK
        DST      : in  STD_LOGIC;                            -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_encoder.vhd-DST
        GPS      : in  STD_LOGIC_VECTOR(31 downto 0);        -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_encoder.vhd-GPS[31..0]
        IEEE1344 : in  STD_LOGIC;                            -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_encoder.vhd-IEEE1344
        ISLAST   : out STD_LOGIC;                            -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_encoder.vhd-ISLAST
        ISLEAP   : out STD_LOGIC;                            -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_encoder.vhd-ISLEAP
        LEAP     : in  STD_LOGIC_VECTOR(7 downto 0);         -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_encoder.vhd-LEAP[7..0]
        LEAPDEL  : in  STD_LOGIC;                            -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_encoder.vhd-LEAPDEL
        LEAPPEND : in  STD_LOGIC;                            -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_encoder.vhd-LEAPPEND
        ONEPPS   : in  STD_LOGIC;                            -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_encoder.vhd-ONEPPS
        TIMEZONE : in  STD_LOGIC_VECTOR(5 downto 0)          -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_encoder.vhd-TIMEZONE[5..0]
      );
   End Component;

   Component IRIGB_serial                                    -- ObjectKind=Sheet Symbol|PrimaryId=IRIGBSERIAL
      port
      (
        BITS    : in  STD_LOGIC_VECTOR(88 downto 0);         -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_serial.vhd-BITS[88..0]
        CLK     : in  STD_LOGIC;                             -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_serial.vhd-CLK
        IRIGB   : out STD_LOGIC;                             -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_serial.vhd-IRIGB
        ONEEND  : in  STD_LOGIC;                             -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_serial.vhd-ONEEND
        POSCNT  : in  STD_LOGIC_VECTOR(3 downto 0);          -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_serial.vhd-POSCNT[3..0]
        POSEND  : in  STD_LOGIC;                             -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_serial.vhd-POSEND
        POSMARK : in  STD_LOGIC;                             -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_serial.vhd-POSMARK
        SYMCNT  : in  STD_LOGIC_VECTOR(3 downto 0);          -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_serial.vhd-SYMCNT[3..0]
        SYMMARK : in  STD_LOGIC;                             -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_serial.vhd-SYMMARK
        ZEROEND : in  STD_LOGIC                              -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_serial.vhd-ZEROEND
      );
   End Component;


    Signal NamedSignal_BITS             : STD_LOGIC_VECTOR(88 downto 0); -- ObjectKind=Net|PrimaryId=BITS[88..0]
    Signal PinSignal_IRIGBCLK_ONEEND    : STD_LOGIC; -- ObjectKind=Net|PrimaryId=ONEEND
    Signal PinSignal_IRIGBCLK_POSCNT    : STD_LOGIC_VECTOR(3 downto 0); -- ObjectKind=Net|PrimaryId=POSCNT
    Signal PinSignal_IRIGBCLK_POSEND    : STD_LOGIC; -- ObjectKind=Net|PrimaryId=POSEND
    Signal PinSignal_IRIGBCLK_POSMARK   : STD_LOGIC; -- ObjectKind=Net|PrimaryId=POSMARK
    Signal PinSignal_IRIGBCLK_SYMCNT    : STD_LOGIC_VECTOR(3 downto 0); -- ObjectKind=Net|PrimaryId=SYMCNT
    Signal PinSignal_IRIGBCLK_SYMMARK   : STD_LOGIC; -- ObjectKind=Net|PrimaryId=SYMMARK
    Signal PinSignal_IRIGBCLK_ZEROEND   : STD_LOGIC; -- ObjectKind=Net|PrimaryId=ZEROEND
    Signal PinSignal_IRIGBENCODE_BITS   : STD_LOGIC_VECTOR(88 downto 0); -- ObjectKind=Net|PrimaryId=BITS[88..0]
    Signal PinSignal_IRIGBENCODE_ISLAST : STD_LOGIC; -- ObjectKind=Net|PrimaryId=ISLAST
    Signal PinSignal_IRIGBENCODE_ISLEAP : STD_LOGIC; -- ObjectKind=Net|PrimaryId=ISLEAP
    Signal PinSignal_IRIGBSERIAL_IRIGB  : STD_LOGIC; -- ObjectKind=Net|PrimaryId=IRIGB

Begin
    IRIGBSERIAL : IRIGB_serial                               -- ObjectKind=Sheet Symbol|PrimaryId=IRIGBSERIAL
      Port Map
      (
        BITS    => PinSignal_IRIGBENCODE_BITS,               -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_serial.vhd-BITS[88..0]
        CLK     => CLK,                                      -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_serial.vhd-CLK
        IRIGB   => PinSignal_IRIGBSERIAL_IRIGB,              -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_serial.vhd-IRIGB
        ONEEND  => PinSignal_IRIGBCLK_ONEEND,                -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_serial.vhd-ONEEND
        POSCNT  => PinSignal_IRIGBCLK_POSCNT,                -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_serial.vhd-POSCNT[3..0]
        POSEND  => PinSignal_IRIGBCLK_POSEND,                -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_serial.vhd-POSEND
        POSMARK => PinSignal_IRIGBCLK_POSMARK,               -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_serial.vhd-POSMARK
        SYMCNT  => PinSignal_IRIGBCLK_SYMCNT,                -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_serial.vhd-SYMCNT[3..0]
        SYMMARK => PinSignal_IRIGBCLK_SYMMARK,               -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_serial.vhd-SYMMARK
        ZEROEND => PinSignal_IRIGBCLK_ZEROEND                -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_serial.vhd-ZEROEND
      );

    IRIGBENCODE : IRIGB_encoder                              -- ObjectKind=Sheet Symbol|PrimaryId=IRIGBENCODE
      Port Map
      (
        BITS     => PinSignal_IRIGBENCODE_BITS,              -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_encoder.vhd-BITS[88..0]
        CLK      => CLK,                                     -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_encoder.vhd-CLK
        DST      => DST,                                     -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_encoder.vhd-DST
        GPS      => GPS,                                     -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_encoder.vhd-GPS[31..0]
        IEEE1344 => IEEE1344,                                -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_encoder.vhd-IEEE1344
        ISLAST   => PinSignal_IRIGBENCODE_ISLAST,            -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_encoder.vhd-ISLAST
        ISLEAP   => PinSignal_IRIGBENCODE_ISLEAP,            -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_encoder.vhd-ISLEAP
        LEAP     => LEAP,                                    -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_encoder.vhd-LEAP[7..0]
        LEAPDEL  => LEAPDEL,                                 -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_encoder.vhd-LEAPDEL
        LEAPPEND => LEAPPEND,                                -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_encoder.vhd-LEAPPEND
        ONEPPS   => ONEPPS,                                  -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_encoder.vhd-ONEPPS
        TIMEZONE => TIMEZONE                                 -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_encoder.vhd-TIMEZONE[5..0]
      );

    IRIGBCLK : IRIGB_clock                                   -- ObjectKind=Sheet Symbol|PrimaryId=IRIGBCLK
      Port Map
      (
        CLK     => CLK,                                      -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_clock.vhd-CLK
        ONEEND  => PinSignal_IRIGBCLK_ONEEND,                -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_clock.vhd-ONEEND
        ONEPPS  => ONEPPS,                                   -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_clock.vhd-ONEPPS
        POSCNT  => PinSignal_IRIGBCLK_POSCNT,                -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_clock.vhd-POSCNT[3..0]
        POSEND  => PinSignal_IRIGBCLK_POSEND,                -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_clock.vhd-POSEND
        POSMARK => PinSignal_IRIGBCLK_POSMARK,               -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_clock.vhd-POSMARK
        SYMCNT  => PinSignal_IRIGBCLK_SYMCNT,                -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_clock.vhd-SYMCNT[3..0]
        SYMMARK => PinSignal_IRIGBCLK_SYMMARK,               -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_clock.vhd-SYMMARK
        ZEROEND => PinSignal_IRIGBCLK_ZEROEND                -- ObjectKind=Sheet Entry|PrimaryId=IRIGB_clock.vhd-ZEROEND
      );

    -- Signal Assignments
    ---------------------
    BITS             <= NamedSignal_BITS; -- ObjectKind=Net|PrimaryId=BITS[88..0]
    IRIG             <= PinSignal_IRIGBSERIAL_IRIGB; -- ObjectKind=Net|PrimaryId=IRIGB
    ISLAST           <= PinSignal_IRIGBENCODE_ISLAST; -- ObjectKind=Net|PrimaryId=ISLAST
    ISLEAP           <= PinSignal_IRIGBENCODE_ISLEAP; -- ObjectKind=Net|PrimaryId=ISLEAP
    NamedSignal_BITS <= PinSignal_IRIGBENCODE_BITS; -- ObjectKind=Net|PrimaryId=BITS[88..0]

End Structure;
------------------------------------------------------------

